module PipeRpc
  class Client::Request::Result
    def initialize(request)
      @request = request
    end

    def value=(result)
      @received = true
      @value = result
    end

    def received?
      @received
    end

    def value
      if @value.is_a? Exception
        @value.set_backtrace(@value.backtrace.to_a + @request.stacktrace) if @value.respond_to? :set_backtrace
        raise @value
      else
        @request.hub.transport_mapper.from_transport @value
      end
    end
  end
end