module PipeRpc
  class Error < StandardError; end
  class ClosedError < Error; end
  class UnknownError < Error; end
  class ServerRegistrationError < Error; end
  class ClientInitializationError < Error; end

  class MessageError < Error; end
  class MessageParseError < MessageError; end
  class InvalidMessageError < MessageError; end

  class EvaluationError < Error; end
  class NoMethodError < EvaluationError; end
  class ArgumentError < EvaluationError; end
  class InternalError < EvaluationError; end
  class NoServerError < EvaluationError; end
  class ReflectedError < EvaluationError; end
end