module PipeRpc
  class Hub
    def initialize(gateway, channels)
      @channel = channels[:input]
      @socket = Socket.new(self, channels)
      @requests = Requests.new(self)
      @servers = Servers.new
      @clients = Clients.new(self)
      @transport_mapper = TransportMapper.new(gateway)
    end

    attr_reader :channel, :servers, :clients, :requests, :socket, :transport_mapper

    def handle_message
      Message.new(self, @socket.read).handle
    end
  end
end